clear;
close all;

% ==== test images ====
original_image = (imread('traffic_gray.png')); 


% ==== convert the dynamic range into [0,1] ====
I = im2double(original_image);


% ==== noise model parameters ====
a= 0.1^2;
b =0.02^2;

% a= 0.2^2;
% b =0.04^2;

% a= 0.4^2;
% b =0.08^2;


% ===== synthesized Poisson-Gaussian (PG) noise ======
if a == 0
    noisy_image = I;
else
    noisy_image = poissrnd(I/a) * a;
end
noisy_image = noisy_image + sqrt(b) * randn(size(I));
figure;imshow(noisy_image,[]);

% ===== image sensor noise model (PG noise) parameter estimation ======
[est_a, est_b] = NoiseEstCWLS(noisy_image);


% ===== plots =====
figure;
x = 0:1/255:1;
plot(x, sqrt(a*x+b),':g','LineWidth',1.5);
hold on;
plot(x, sqrt(est_a*x+est_b),'-r','LineWidth',1.5);
grid on;
rmse = sqrt(    mean(   (sqrt(a*x+b)-sqrt(est_a*x+est_b)).^2     ) );
fprintf( ' The RMSE = %.5f\n', rmse );
xlabel('Intensity Level','FontSize',13,'FontWeight','bold');
ylabel('Noise Level','FontSize',13,'FontWeight','bold');
legend('Ground-truth Noise Level Function','Estimated Noise Level Function','Location','northwest');
set(gca,'fontsize',11.5,'FontWeight','bold');



