clear; close all;
patchSize =5;
bitdepth = 255;

% ==== parameters for noise model ====
% clean image
a=0;
b =0;

% noisy image with different parameters
% a= 0.1^2;
% b =0.02^2;

% a= 0.2^2;
% b =0.04^2;

% a= 0.4^2;
% b =0.08^2;


kh = [-1/2,0,1/2];
kv = kh';
Dh = convmtx2(kh,patchSize,patchSize);%generate horizontal derivative opeator (using matrix)
Dv = convmtx2(kv,patchSize,patchSize);
DD = Dh'*Dh+Dv'*Dv;

% ==== clean / noisy selection comparsion ====
I = (imread('bear.jpg'));% bear


if ~ismatrix(I)
    I = (rgb2gray(I));
end


I = im2double(I);
orgimg = I;

if a == 0
    noisy_image = I;
else
    noisy_image = poissrnd(I/a) * a;
end
I = noisy_image + sqrt(b) * randn(size(I));

vec_image = im2col( I, [patchSize patchSize], 'sliding' );
mean_vec_image = (mean(vec_image,1));
[bincnt, ~] = histc(mean_vec_image,1/bitdepth:1/bitdepth:255/bitdepth);
[occurs, intensities] = sort(bincnt,'descend');
temp = bincnt; 
temp(temp==0) =[];
N = 50;
xbars = intensities(1:N)/bitdepth;
all_strength = texture_strength_mean( vec_image-repmat(mean_vec_image,patchSize^2,1), DD);
t = quantile(all_strength,0.5);

p = zeros(size(vec_image,2),1);
pp = zeros(size(vec_image,2),1);
All = zeros(N,4);
com_bincnt = zeros(size(bincnt));
for k = 1:N
        xbar = xbars(k);
        % select the patch with similar mean, with the allowed variantion
        select_patch = (mean_vec_image>=xbar-0.5/bitdepth & mean_vec_image<=xbar+0.5/bitdepth);
        select_vec_image = vec_image(:,select_patch);
        select_vec_image = select_vec_image - xbar;
        
       
        prob = occurs(k)/sum(occurs);
        % compute the weight for this sample
        select_strength = texture_strength_mean( select_vec_image, DD);
        pp(select_patch) = 1;
        
        All(k,:) =    [xbar, prob, sum(select_strength<t)/length(select_strength),length(select_strength)];
        com_bincnt(intensities(k)) = length(select_strength);
end
strength = texture_strength_mean( vec_image, DD);
p(strength<t) = 1;
% ==== original image ====
imshow(I);

% ==== image histogram ====
figure;bar(bincnt); xlabel('Pixel Intensity'); ylabel('Occurrences'); set(gca,'fontsize',13,'FontWeight','bold');
figure;bar(com_bincnt); xlabel('Pixel Intensity'); ylabel('Occurrences'); set(gca,'fontsize',13,'FontWeight','bold');

% ==== relationship between histogram and patch texture strength =====
figure;scatter(1:N,All(:,3)); hold on;

a = (1:N)';
A = [a,ones(N,1)];
b = All(:,3);
x = robustfit(a,b);
plot(a,A*x(end:-1:1),'r-','LineWidth',3);
grid on;
xlabel('Index of Sorted Histogram Bin','FontSize',13,'FontWeight','bold');
ylabel('Empirical Conditional Probability','FontSize',13,'FontWeight','bold');
legend('Empirical Conditional Probability','                Fitted Line','Location','northeast');
set(gca,'fontsize',11.5,'FontWeight','bold');

% ==== selected regions ====
displaySelectPixels( orgimg, pp, patchSize); 

