function [ s ] = texture_strength_mean( X, DD)
% X: each column is a vectorized patch
% s: row vector, each one represents the texture strength

% temp = X'*DD;
% s = zeros(1,size(X,2));
% for i =1:size(X,2)
%     s(i) = temp(i,:)*X(:,i);
% end

% simple but not efficient (requires amount of memory)
% s = diag(X'*DD*X);

% speed up without computing the undiagonal elements
s = sum( (X'*DD).*X',2);
s = s';
end





